﻿------------------------------------------------------------------------------------------------------
-- Initialise the addon and required libraries
------------------------------------------------------------------------------------------------------
local L = AceLibrary("AceLocale-2.2"):new("Cryolysis2")
local waterfall = AceLibrary("Waterfall-1.0")
local candybar = AceLibrary("CandyBar-2.0")

------------------------------------------------------------------------------------------------------
-- Initialise the variable we will be working with
------------------------------------------------------------------------------------------------------
Cryolysis2 = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
local Cryolysis2 = Cryolysis2;

------------------------------------------------------------------------------------------------------
-- What happens when the addon is first loaded
------------------------------------------------------------------------------------------------------
function Cryolysis2:OnInitialize()
	-- Register the database
	Cryolysis2:RegisterDB("Cryolysis2Config", "Cryolysis2ConfigPC");
	
	-- Create various variables
    Cryolysis2:CreatePrivateVars();
	Cryolysis2:CreateOptions();
	Cryolysis2:CreateDefaults();
	Cryolysis2:CreateMounts();
	
	-- Register these created variables
	Cryolysis2:RegisterChatCommand("/cryolysis", "/cryo", Cryolysis2.slashopts)
	Cryolysis2:RegisterDefaults("profile", Cryolysis2.defaults)
	
	-- Enable the addon
	Cryolysis2:ToggleActive(true);
end

------------------------------------------------------------------------------------------------------
-- What happens when the addon is enabled
------------------------------------------------------------------------------------------------------
function Cryolysis2:OnEnable()
	-- Register various events
	Cryolysis2:RegisterEvents();

	Cryolysis2:PLAYER_ENTERING_WORLD() -- Inefficient, but allows the class check to work properly
end

------------------------------------------------------------------------------------------------------
-- What happens when the addon is disabled
------------------------------------------------------------------------------------------------------
function Cryolysis2:OnDisable()

	local f;

	Cryo2MainSphere:Hide();

	for i = 1, #(Cryolysis2.db.profile.Buttons), 1 do
		f = getglobal(Cryolysis2.db.profile.Buttons[i])
		f:Hide()
	end
	for i = 1, #(Cryolysis2.Private.BuffMenu), 1 do
		f = getglobal(Cryolysis2.Private.BuffMenu[i])
		f:Hide()
	end
	for i = 1, #(Cryolysis2.Private.GemMenu), 1 do
		f = getglobal(Cryolysis2.Private.GemMenu[i])
		f:Hide()
	end

	for i = 1, #(Cryolysis2.Private.PortMenu), 1 do
		f = getglobal(Cryolysis2.Private.PortMenu[i])
		f:Hide()
	end

end

------------------------------------------------------------------------------------------------------
-- What happens when the menu is opened
------------------------------------------------------------------------------------------------------
function Cryolysis2:OpenMenu()
	waterfall:Open('Cryo2Waterfall')
end